/*

H16 blog reader

*/

const articles = document.querySelectorAll('article.comment-block');
var articlesJSON = [];

function GetSortOrder(prop) {    
    return function(a, b) {    
        if (a[prop] > b[prop]) {    
            return -1;    
        } else if (a[prop] < b[prop]) {    
            return 1;    
        }    
        return 0;    
    }    
} 

for (let index = 0; index < articles.length; index++) {
    articlesJSON.push({
        id:articles[index].getAttribute('id'),
        author:articles[index].getElementsByTagName('cite')[0].textContent,
        postDate:articles[index].getElementsByTagName('time')[0].textContent,
        postText:articles[index].getElementsByClassName('comment-content comment')[0].textContent.slice(0,128),
        postHref:articles[index].getElementsByClassName('comment-permalink')[0].getAttribute('href')

    });
}

articlesJSON.sort(GetSortOrder("id"));

var mainPanel = document.createElement('div');
mainPanel.setAttribute('id','nav-overlay-panel');
mainPanel.classList.add('navOverlay');

document.body.appendChild(mainPanel);

var panelHeaderDiv =  document.createElement('div');
panelHeaderDiv.classList.add('panelHeader');

var nextPageNav = document.getElementById("comment-nav-below");
if (nextPageNav != null) {
    
    var nextButton = document.createElement('button');

    var previousNavDiv = nextPageNav.getElementsByClassName('nav-previous')[0];
        if (previousNavDiv.getElementsByTagName('a')[0] != null) {

            var hrefPrev =previousNavDiv.getElementsByTagName('a')[0].href.toString();
            var previousButton = document.createElement('button');
            previousButton.classList.add('buttons');
            previousButton.innerHTML = '&#129128;';
            previousButton.setAttribute('onclick',`window.location.href ='${hrefPrev};'`);
            
            panelHeaderDiv.appendChild(previousButton);
        }
    
    var nextNavDiv = nextPageNav.getElementsByClassName('nav-next')[0];
        if (nextNavDiv.getElementsByTagName('a')[0] != null) {

            var hrefPrev =nextNavDiv.getElementsByTagName('a')[0].href.toString();
            var nextButton = document.createElement('button');
            nextButton.classList.add('buttons');
            nextButton.innerHTML = '&#129130;';
            nextButton.setAttribute('onclick',`window.location.href ='${hrefPrev};'`);
            
            panelHeaderDiv.appendChild(nextButton);
        }
    
}

var closeButton = document.createElement('button');
closeButton.classList.add('closeBtn','buttons');
closeButton.innerHTML = '&#x2a2f;';
closeButton.onclick = function(){document.getElementById('nav-overlay-panel').style.left = "-400px";};

panelHeaderDiv.appendChild(closeButton);

mainPanel.appendChild(panelHeaderDiv);

var msgPanel =document.createElement('div');
msgPanel.setAttribute('id','msgPanel');
msgPanel.classList.add('msgPanelStyle');

var overlayHtml = "";

for (let i = 0; i < articlesJSON.length; i++) {
    var paraDiv = document.createElement('div');
    paraDiv.classList.add("msgDiv");

    var headerDiv = document.createElement('div');
    headerDiv.classList.add("postHeaderDiv");

    var p1  = document.createElement('p');
    p1.classList.add("alignLeft");
    p1.innerText = articlesJSON[i].author;

    var p2  = document.createElement('p');
    p2.classList.add("alignRight");
    p2.innerText = articlesJSON[i].postDate;

    headerDiv.appendChild(p1);
    headerDiv.appendChild(p2);

    var commentDiv = document.createElement('div');
    commentDiv.style.clear = "both";

    var a = document.createElement('a');
    a.classList.add('msgText');
    a.setAttribute('href',articlesJSON[i].postHref);

    var txt = document.createTextNode(articlesJSON[i].postText+'...');
    a.appendChild(txt);

    commentDiv.appendChild(a);

    paraDiv.appendChild(headerDiv);
    paraDiv.appendChild(commentDiv);
    
    msgPanel.appendChild(paraDiv);    
}

mainPanel.appendChild(msgPanel);

const showPanel = document.createElement('div');
showPanel.classList.add('showPanelDiv');
showPanel.setAttribute('onclick',"document.getElementById('nav-overlay-panel').style.setProperty('left','0px');");

showPanel.innerHTML = '<p>&#10097;</p>';

document.body.appendChild(showPanel);
